﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NHibernate;
using NHibernate.Linq;

//TODO: composite primary keys
//http://mywiki.igorbrejc.net/index.php?title=Fluent_NHibernate_Samples
namespace FluentNHibernateMappings
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ISession session = MSSQLSessionFactory.OpenSession())
            {
                // Test query of data by selecting only the teacher records
                var query = (from t in session.Query<Teacher>()
                             select t).ToList();

                foreach (var teacheritem in query)
                {
                    foreach (var classitem in teacheritem.Classes)
                    {
                        Console.WriteLine("Class:" + classitem.Name.Trim() + " Teacher:" + teacheritem.Name.Trim());
                    }
                }

                // Test inserts
                Teacher newteacher = new Teacher() { Name = "Delete ME" };
                session.Save(newteacher);

                Class newclass = new Class() { Name = "TECH01", Teacher = newteacher };
                newteacher.Classes.Add(newclass);
                session.Save(newclass);

                newclass = new Class() { Name = "TECH02", Teacher = newteacher };
                newteacher.Classes.Add(newclass);
                session.Save(newclass);

                // Test update parent and children
                using (session.BeginTransaction())
                {
                    newteacher.Classes[0].Name = "NONTECH01";
                    newteacher.Classes[1].Name = "NONTECH02";
                    newteacher.Name = "Delete 2";
                    session.Update(newteacher);
                    session.Transaction.Commit();
                }

                // Test cascade deletes
                using (session.BeginTransaction())
                {
                    session.Delete(newteacher);
                    session.Transaction.Commit();
                }

                Console.ReadKey();
            }
        }
    }
}
