﻿using FluentNHibernate.Mapping;
using System.Collections.Generic;

namespace FluentNHibernateMappings
{
    public class Teacher
    {
        public virtual int Id { get; set; }
        public virtual string Name { get; set; }
        public virtual IList<Class> Classes { get; set; }

        public Teacher()
        {
            Classes = new List<Class>();
        }
    }

    public class TeacherMap : ClassMap<Teacher>
    {
        public TeacherMap()
        {
            Id(u => u.Id).GeneratedBy.Identity();
            Map(u => u.Name).Nullable();
            HasMany(u => u.Classes)
                .KeyColumn("TeacherId")
                .Inverse()
                .Cascade.All();
        }
    }
}

